using System;
using System.Runtime.InteropServices;

internal static class NativeMethods {
    [DllImport("purebasic.dll")]
    internal static extern bool Function_1();

    [DllImport("purebasic.dll")]
    internal static extern bool Function_2(System.Int32 value);

    [DllImport("purebasic.dll")]
    internal static extern System.Int32 Function_3(System.Int64 value);

    [DllImport("purebasic.dll")]
    [return: MarshalAs(UnmanagedType.LPWStr)] // returns UNICODE string
    internal static extern string Function_4 (
        [MarshalAs(UnmanagedType.LPWStr)] string s // UNICODE string
    );
}

class Program {
    static void Main() {
        NativeMethods.Function_1();
        NativeMethods.Function_2(12);
        
        Int32 i = NativeMethods.Function_3(0xABCDEFABCDEFABC);
        
        System.Windows.Forms.MessageBox.Show("purebasic.dll Function_3() returned: " + i.ToString());

        string s = NativeMethods.Function_4("C# String");

        System.Windows.Forms.MessageBox.Show("purebasic.dll Function_4() returned: " + s);
    }
}
