using System;
using System.Runtime.InteropServices;


class Program {

    [DllImport("purebasic.dll")]
    internal static extern bool Function_1();

    [DllImport("purebasic.dll")]
    internal static extern bool Function_2(System.Int32 value);

    [DllImport("purebasic.dll")]
    internal static extern System.Int32 Function_3(System.Int64 value);

    [DllImport("purebasic.dll")]
    [return: MarshalAs(UnmanagedType.LPWStr)] // returns UNICODE string
    internal static extern string Function_4 (
        [MarshalAs(UnmanagedType.LPWStr)] string s // UNICODE string
    );


    static void Main() {
        Function_1();
        Function_2(12);
        
        Int32 i = Function_3(0xABCDEFABCDEFABC);
        
        System.Windows.Forms.MessageBox.Show("purebasic.dll Function_3() returned: " + i.ToString());

        string s = Function_4("C# String");

        System.Windows.Forms.MessageBox.Show("purebasic.dll Function_4() returned: " + s);
    }
}
